
#ifndef COLLAPSIBLEDOCKWIDET_HH
#define COLLAPSIBLEDOCKWIDET_HH

#include <QAbstractButton>
#include <QAction>
#include <QDockWidget>
#include <QObject>
#include <QRect>
#include <QString>

#include "bda/myqtwidgets_export.h"

class MYQTWIDGETS_EXPORT CollapsibleDockWidget : public QDockWidget {
    Q_OBJECT

public:
    explicit CollapsibleDockWidget(const QString& title, QWidget* parent = nullptr, Qt::WindowFlags flags = Qt::WindowFlags());
    explicit CollapsibleDockWidget(QWidget* parent = nullptr, Qt::WindowFlags flags = Qt::WindowFlags());
    virtual ~CollapsibleDockWidget();

    void setWidget(QWidget* widget);

    void collapse(const bool aCollapse);
    bool isCollapsed();

signals:
    void collapsed(const bool aCollapsed);

public slots:
    void onCollapseToggle();

private:
    bool mCollapsed;
    QAbstractButton* vButton;

    int mOriginalMinHeight;
    int mOriginalMaxHeight;
    int mOriginalHeight;
    QWidget* mWidget;
};

#endif
